<?php

    function create_directory($path, $hta) {
        $htaccess = array('alow' => 'Allow from all', 'deny' => 'Deny from all');

        $local_copy_path = trim($path, "\/");

        $directory = preg_replace("/\//us", "\\", $local_copy_path);

        $check = true;

        $check_dir = is_dir($path);

        if (!$check_dir) {
            $check_dir = mkdir($directory, 0755, true);
        }

        $create_htaccess = file_put_contents($directory . '/.htaccess', $htaccess[$hta]);

        if (!$check_dir || !$create_htaccess) {

            return false;
        } else {

            return true;
        }
    }

    function load_template($template, $data = false, $settings = false) {
        ob_start();
        include( $template );
        $template = ob_get_contents();
        ob_end_clean();
        return $template;
    }

    function get_news() {
        $pages = get_files(GSDATAPAGESPATH, 'xml', true);
        $pages = array_change_values($pages, NEWS_DIR);
        return get_files($pages, 'xml');
    }

    function get_page_news($page) {
        return get_files(NEWS_DIR . $page . '/', 'xml');
    }

    function get_settings($path = false) {

        if (!$path) {
            $path = NEWS_SETTINGS;
        }

        $settings = getXML($path);
        return html_ent_decode($settings);
    }

    function get_news_number() {
        $news = get_news();
        return count($news, COUNT_RECURSIVE) - count($news);
    }

    function get_messages($data, $success, $fail, $extra = '') {

        if (!$data) {
            $result = '<div class="error">' . $fail . ' ' . $extra . '</div>';
        } else {
            $result = '<div class="updated">' . $success . ' ' . $extra . '</div>';
        }
        return $result;
    }

    function installed_languages() {
        $lang_handle = opendir(GSLANGPATH) or die("Unable to open " . GSLANGPATH);

        while ($lfile = readdir($lang_handle)) {
            if (is_file(GSLANGPATH . $lfile) && $lfile != "." && $lfile != "..") {
                $lang_array[] = basename($lfile, ".php");
            }
        }
        return $lang_array;
    }

    function html_ent($data) {

        foreach ($data as $key => $val) {
            $result[$key] = htmlentities($val, ENT_QUOTES, 'UTF-8');
        }
        return $result;
    }

    function html_ent_decode($data) {

        foreach ($data as $key => $val) {
            $result[$key] = htmldecode($val);
        }
        return $result;
    }

    function array_keys_rename($array, $search, $replacement) {
        $keys = array_keys($array);
        $values = array_values($array);

        for ($i = 0; $i < count($keys); $i++) {

            $keys[$i] = str_replace($search, $replacement, $keys[$i]);
        }

        return array_combine($keys, $values);
    }

    function array_change_values($array, $add) {
        $keys = array_keys($array);
        $values = array_values($array);

        for ($i = 0; $i < count($keys); $i++) {
            $keys[$i] = $values[$i];
            $values[$i] = $add . $values[$i];
        }
        return array_combine($keys, $values);
    }

    function array_to_xml($info, &$xml_info) {

        foreach ($info as $key => $value) {
            if (is_array($value)) {
                if (!is_numeric($key)) {
                    $subnode = $xml_info->addChild("$key");
                    array_to_xml($value, $subnode);
                } else {
                    array_to_xml($value, $xml_info);
                }
            } else {
                $value = htmlentities($value, ENT_QUOTES, 'UTF-8');
                if (is_numeric($key)) {

                    $xml_info->addChild("data", "$value");
                } else {

                    $xml_info->addChild("$key", "$value");
                }
            }
        }
    }

    function check_mail($email) {

        require_once 'is_email.php';

        if (is_email($email)) {

            return true;
        } else {

            return false;
        }
    }

    function init_navigation($access_key, $main_function, $menu_item) {

        $code = '<li id="nav_users"><a accesskey="' . $access_key . '" href="load.php?id=' . $main_function . '" ';

        if (isset($_GET['id']) && $_GET['id'] == "' . $main_function . '") {

            $code .= 'class="tabSelected" ';
        }

        $code .= '>' . $menu_item . '</a></li>';

        return $code;
    }

    function init_scripts($script_path, $type) {

        $sc = array();
        if (!is_array($script_path)) {

            $sc[0] = $script_path;
        } else {
            $sc = $script_path;
        }

        $script = '';
        if ($type == 'css') {

            $pre = '<link href="';
            $post = '" rel="stylesheet">';
        } elseif ($type == 'js') {

            $pre = '<script type="text/javascript" src="';
            $post = '"></script>';
        }

        foreach ($sc as $key => $path) {

            $script .= $pre . $path . $post . "\n";
        }

        return $script;
    }

    function international_set($plugin_name, $language) {

        i18n_merge($plugin_name) || i18n_merge($plugin_name, $language);
    }

    function check_constants($constants) {

        foreach ($constants as $def => $val) {
            if (!defined('' . $def . ''))
                define('' . $def . '', '' . $val . '');
        }
    }

    function find_themes() {

        return glob(GSTHEMESPATH . '*', GLOB_ONLYDIR);
    }

    function get_files($path, $extension, $basename = false) {
        $files = array();

        if (is_array($path)) {

            foreach ($path as $key => $value) {

                $files = glob($value . '/*' . $extension);
                if (!empty($files)) {
                    usort($files, create_function('$a,$b', 'return filemtime($b) - filemtime($a);'));
                    // $files[$key] = $files;
                    //exit;

                    if ($basename) {
                        $extension = "." . $extension;
                        $files = get_basename_array($files, $extension);
                    }
                } else {
                    $files = 'empty';
                }

                $result[$key] = $files;
                $files = '';
            }
        } else {

            $result = glob($path . '/*' . $extension);
            usort($result, create_function('$a,$b', 'return filemtime($b) - filemtime($a);'));
            if ($basename) {
                $extension = "." . $extension;

                $result = get_basename_array($result, $extension);
            }
        }

        if (count($result) > 0) {

            return $result;
        }
    }

    function get_basename_array($files, $extension) {
        $result = array();
        foreach ($files as $key => $file) {
            $result[$key] = basename($file, $extension);
        }
        return $result;
    }

    function construct_dropdown($s_name, $s_class, $data, $selected = false, $extra = '', $keys = false) {

        $select = '<select class="' . $s_class . '" id="' . $s_name . '" name="' . $s_name . '" ' . $extra . '>';

        foreach ($data as $key => $value) {
            if (!$keys) {
                if ($selected && $selected == $value) {
                    $select .= '<option selected="" value="' . $value . '">' . $value . '</option>';
                } else {
                    $select .= '<option value="' . $value . '">' . $value . '</option>';
                }
            } else {

                if ($selected && $selected == $key) {
                    $select .= '<option selected="" value="' . $key . '">' . $value . '</option>';
                } else {
                    $select .= '<option value="' . $key . '">' . $value . '</option>';
                }
            }
        }
        $select .= '</select>';

        return $select;
    }

    function tide_createSideMenu($id, $txt, $action = null, $always = true, $clickable = true) {
        $current = false;
        if (isset($_GET['id']) && $_GET['id'] == $id && (!$action || isset($_GET[$action]))) {
            $current = true;
        }
        if ($always || $current) {
            echo '<li id="sb_' . $action . '">';
            if ($clickable) {
                echo '<a href="load.php?id=' . $id . ($action ? '&amp;' . $action : '') . '" ' . ($current ? 'class="current"' : '') . ' >' . $txt . '</a>';
            } else {
                echo $txt;
            }
            echo '</li>';
        }
    }

    function input_sanitize($data, $type) {

        if ($type == 'name') {

            $alowed = 'alpha';
        } else if ($type == 'nick') {

            $alowed = array(" ", "-", "_", "@", "#", "&", "+", "$", ",", "/", ":", ";", "=", "?", "(", ")", "*", "%", "!");
        } else if ($type == 'mail') {
            
        } else {
            
        }

        //*******************************************************************
        // let's loop each pair of values eg. $_POST['name'] = 'someName';
        //*******************************************************************
        foreach ($this->input_field_arrays as $key => $value) {

            //*******************************************************************
            //ok now we must check if somebody didn't use encoded special chars
            //*******************************************************************
            $value = htmlspecialchars_decode(urldecode($value));

            //*******************************************************************
            //now we must remove allowed chars because ctype_alnum support just alpha numer characters
            //and we check if there are some restricted characters left
            //*******************************************************************
            if (ctype_alnum(str_replace($this->alowed_Chars, "", $value))) {
                //*******************************************************************
                //if we do not have restricted chars reconstruct array of checked data
                $this->cleaned_input[$key] = $value;

                //*******************************************************************
            } else {
                //if we have restricted chars reconstruct array and set array value to error
                $this->cleaned_input[$key] = 'error';
            }
        }
        return $this->cleaned_input;
    }

    function url_builder($page, $news) {

        if (PRETTY_URLS == '1') {
            $url = SITE_URL . 'page-' . $page . '-news-' . $news;
        } else {
            $url = SITE_URL . 'index.php?id=' . $page . '&amp;show_news&amp;current_news=' . $news;
        }
        return $url;
    }
    
    function url_builder_pages($page, $news, $current) {

        if (PRETTY_URLS == '1') {
            $url = SITE_URL . 'page-' . $page . '-' . $current .'-news-' . $news;
        } else {
            $url = SITE_URL . 'index.php?id=' . $page . '&amp;show_news&amp;page=' . $current .'&amp;current_news=' . $news;
        }
        return $url;
    }

    function rss_buider($page) {

        if (PRETTY_URLS == '1') {
            $url = SITE_URL . 'rss-' . $page;
        } else {
            $url = SITE_URL . 'index.php?id=rss&amp;page=' . $page;
        }
        return $url;
    }

    function nav_default($page, $page_num, $old_new) {

        if (PRETTY_URLS == '1') {
            $url = SITE_URL . $page . '-page-' . $page_num;
        } else {
            $url = SITE_URL . 'index.php?id=' . $page . '&show_news&page_number=' . $page_num;
        }
        return $url;
    }

    function nav_news_admin($page, $page_num, $old_new) {
        $url = SITE_URL . 'admin/load.php?id=tide_news&amp;news_overview=' . $page . '&amp;page_number=' . $page_num;
        return $url;
    }

    function nav_drop_down($page, $page_num, $extra = false) {
        foreach ($page_num as $key => $value) {
            if ($extra) {
                $value++;
                $key++;
            }
            if (PRETTY_URLS == '1') {
                $url[$key] = SITE_URL . $page . '-page-' . $value;
            } else {
                $url[$key] = SITE_URL . 'index.php?id=' . $page . '&show_news&page_number=' . $value;
            }
        }
        return $url;
    }

    function nav_old_new($last, $current_page, $page, $function) {

        if ($current_page == 1) {
            $older_link = call_user_func_array($function, array($page, $current_page + 1, 'older'));
            $data['older'] = '<a href="' . $older_link . '">' . i18n_r('tide_news/NEWS_PAG_OLD') . '</a>';
            $data['newer'] = '';
        } else if ($current_page == $last) {
            $newer_link = call_user_func_array($function, array($page, $current_page - 1, 'newer'));
            $data['older'] = '';
            $data['newer'] = '<a href="' . $newer_link . '">' . i18n_r('tide_news/NEWS_PAG_NEW') . '</a>';
        } else {
            $older_link = call_user_func_array($function, array($page, $current_page + 1, 'older'));
            $newer_link = call_user_func_array($function, array($page, $current_page - 1, 'newer'));

            $data['newer'] = '<a href="' . $newer_link . '">' . i18n_r('tide_news/NEWS_PAG_NEW') . '</a>';
            $data['older'] = '<a href="' . $older_link . '">' . i18n_r('tide_news/NEWS_PAG_OLD') . '</a>';
        }

        return $data;
    }

    function nav_paginate($last, $current_page, $pages_array) {

        $data['paginate'] = '';

        if ($last >= 10 && ($current_page > 3 && $current_page < $last - 3)) {

            $new_array[0] = array_slice($pages_array, 0, 3, true);

            if ($current_page == 4) {
                $new_array[1] = array_slice($pages_array, 3, 3, true);
            } else if ($current_page + 1 <= $last - 3) {
                $new_array[1] = array_slice($pages_array, $current_page - 2, 3, true);
            } else {
                $new_array[1] = array_slice($pages_array, $current_page - 1, 3, true);
            }
            $new_array[2] = array_slice($pages_array, $last - 3, 3, true);
        } elseif ($last >= 10 && ($current_page <= 3 || $current_page >= $last - 3)) {

            $new_array[0] = array_slice($pages_array, 0, 3, true);

            if ($current_page == 3) {
                $new_array[1] = array_slice($pages_array, 3, 3, true);
            } else if ($current_page == $last - 3) {
                $new_array[1] = array_slice($pages_array, $current_page - 3, 3, true);
            } else {
                $new_array[1] = array_slice($pages_array, round($last / 2) - 1, 3, true);
            }

            $new_array[2] = array_slice($pages_array, $last - 3, 3, true);
        }
       
        if ($last < 10) {
            foreach ($pages_array as $key => $value) {

                if ($key == $current_page) {
                    $data['paginate'] .= '<span class="products_current">' . $key . '</span>';
                } else {
                    $data['paginate'] .= '<a  href="' . $value . '"> ' . $key . ' </a>';
                }
            }
            
        } else {

            for ($i = 0; $i < count($new_array); $i++) {
                foreach ($new_array[$i] as $key => $value) {

                    if ($key == $current_page) {
                        $data['paginate'] .= '<span class="products_current">' . $key . '</span>';
                    } else {
                        $data['paginate'] .= '<a  href="' . $value . '"> ' . $key . ' </a>';
                    }
                }

                if (end($new_array) !== $new_array[$i]) {
                    $data['paginate'] .= '...';
                }
            }
        }

        if ($current_page == 1) {
            $data['prev'] = '<span class="products_inactive prew_page"> Previous </span>&nbsp;';
        } else {
            $data['prev'] = '<a class="prew_page"  href="' . $pages_array[$current_page - 1] . '"> Previous </a>&nbsp;';
        }
        echo $current_page . " == " . $last;
        if ($current_page == $last) {
            $data['next'] = '<span class="products_inactive prew_page"> Next </span>&nbsp;';
        } else {
            $data['next'] = '<a class="prew_page"  href="' . $pages_array[$current_page + 1] . '"> Next </a>&nbsp;';
        }
        return $data;
    }

    function create_rss($news, $settings, $extra = false) {

        $settings['encoding'] = 'utf-8';
        $settings['version'] = '2.0';
        $settings['feed_date'] = date("D, d M Y H:i:s T", time());
        $settings['feed_image'] = '';
        if(isset( $settings['feed_image'])){
            $settings['feed_image'] = SITE_URL . 'data/thumbs/thumbsm.' . $settings['feed_image'];
        }
        if ($extra == 'aggregate') {
            $settings['feed_link'] = rss_buider($extra);
            $rss = load_template(TIDE_NEWS_TEMPLATES . 'rss_start.tpl', false, $settings);
        }

        foreach ($news as $page => $value) {

            $settings['feed_link'] = rss_buider($page);

            if ($extra !== 'aggregate') {
                $rss = load_template(TIDE_NEWS_TEMPLATES . 'rss_start.tpl', false, $settings);
            }

            if ($settings['feed_num'] > count($value)) {
                $settings['feed_num'] = count($value);
            }

            if ($value !== 'empty') {
                for ($i = 0; $i < $settings['feed_num']; $i++) {

                    $data = getXML($value[$i]);
                    $data = html_ent_decode($data);

                    $data['news_link'] = url_builder($page, $data['slug']);


                    if (empty($data['summary'])) {
                        $data['summary'] = $data['content'];
                    }
                    $rss .= load_template(TIDE_NEWS_TEMPLATES . 'rss_item.tpl', $data);
                }
            } else if ($value == 'empty' && $extra !== 'aggregate') {
                $data['title'] = i18n_r('tide_news/S_RSS_NODATA_TITLE');
                $data['summary'] = i18n_r('tide_news/S_RSS_NODATA_SUM');
                $data['news_link'] = '';

                $rss .= load_template(TIDE_NEWS_TEMPLATES . 'rss_item.tpl', $data);
            }

            if ($extra !== 'aggregate') {
                $rss .= load_template(TIDE_NEWS_TEMPLATES . 'rss_end.tpl');
                $result[$page] = file_put_contents(NEWS_RSS_DIR . $page . '.xml', $rss);
            }
        }
        if ($extra == 'aggregate') {
            $rss .= load_template(TIDE_NEWS_TEMPLATES . 'rss_end.tpl');

            $result[$extra] = file_put_contents(NEWS_RSS_DIR . $extra . '.xml', $rss);
        }
        return $result;
    }

    function init_editor($instance, $plugin, $language = false, $toolbar = false) {

        if (isset($_GET['id']) and $_GET['id'] == $plugin) {

            if (!$toolbar) {
                $toolbar = "['Bold', 'Italic', 'Underline', 'NumberedList', 'BulletedList', 'JustifyLeft', 'JustifyCenter', 'JustifyRight', 'JustifyBlock', 'Link', 'Unlink', 'Image', 'RemoveFormat', 'Source'],'/',  ['Styles','Format','Font','FontSize'],";
            }

            if (!$language) {
                $language = defined('GSEDITORLANG') ? GSEDITORLANG : 'en';
            }

            if (!is_array($instance)) {
                $instance[0] = $instance;
            }

            $code = '<script type="text/javascript" src="template/js/ckeditor/ckeditor.js"></script>';
            $code .= '<script type="text/javascript">';

            foreach ($instance as $key => $value) {
                $code .= ' var editor = CKEDITOR.replace( "' . $value . '", {
          skin : "getsimple",
          forcePasteAsPlainText : true,
          language : "' . $language . '",
          defaultLanguage : "' . $language . '",
          entities : false,
          uiColor : "#FFFFFF",
          height: "300",
          baseHref : "' . SITE_URL . '",

          toolbar :
          [
          ' . $toolbar . '
          ],
	      tabSpaces:10,
	      filebrowserBrowseUrl : "filebrowser.php?type=all",
              filebrowserImageBrowseUrl : "filebrowser.php?type=images",
	      filebrowserWindowWidth : "730",
	      filebrowserWindowHeight : "500"
        });';
            }
            $code .= '</script>';
        }
        return $code;
    }

    function pr($data) {
        print_r('<pre>');
        print_r($data);
        print_r('</pre>');
    }