<?php

    /*
      Plugin Name: TIDEengine News/Blog Manager
      Description: TIDEengine News/Blog Manager: FANCY URL, RSS Feed, Latest News Menu, News Pagination, News Metadata.
      Version: 3.1+
      Author: Goran Bogdanovic
      Author URI: http://getsimple.tidengine.com
     */


# get correct id for plugin
    $thisfile = basename(__FILE__, '.php');

# register plugin
    register_plugin(
        $thisfile, 'TIDEngine News/Blog Manager', '1.0', 'Goran Bogdanovic', 'http://getsimple.tidengine.com', 'TIDEngine News/Blog Manager: FANCY URL, RSS Feed, Latest News Menu, News Pagination, News Metadata.', $thisfile, 'tide_news_router'
    );

#include helper functions
    include(GSPLUGINPATH . 'TIDEGetSimple/tide_news_helper.php');

# hooks
#Create Main navigation item
    add_action('nav-tab', 'tide_news_nav');

#Add scripts to head
    add_action('theme-header', 'tide_news_css');
    add_action('header', 'tide_news_css');
    add_action('header', 'tide_news_js');

#add plugin links
    add_action($thisfile . '-sidebar', 'tide_createSideMenu', array($thisfile, 'News Overview', 'news_overview'));
    add_action($thisfile . '-sidebar', 'tide_createSideMenu', array($thisfile, 'Create News', 'create_news'));
    add_action($thisfile . '-sidebar', 'tide_createSideMenu', array($thisfile, 'Edit News', 'edit_news', false));
    add_action($thisfile . '-sidebar', 'tide_createSideMenu', array($thisfile, 'News Settings', 'news_settings'));
    add_action('index-pretemplate', 'set_headers');

# activate filter
    if (!function_exists('eval_php_in_content')) {
        add_filter('content', 'evaluate_php_code');
    }

# definitions 
    $constants = array(
        'PLUGIN_PATH' => GSPLUGINPATH . 'tide_news/',
        'NEWS_DIR' => GSDATAPATH . 'news/',
        'NEWS_RSS_DIR' => GSDATAOTHERPATH . 'news_feed/',
        'TIDE_MASTER_DIR' => GSPLUGINPATH . 'TIDEGetSimple/',
        'TIDE_NEWS_TEMPLATES' => GSPLUGINPATH . 'tide_news/templates/',
        'NEWS_RSS_LINK' => GSDATAOTHERPATH . 'news_feed/feed.xml',
        'NEWS_SETTINGS' => GSPLUGINPATH . 'tide_news/settings.xml',
        'STORAGE_SETTINGS' => GSPLUGINPATH . 'tide_news/storage.xml',
        'SITE_URL' => $SITEURL,
        'PRETTY_URLS' => $PRETTYURLS,
        'SITE_NAME' => $SITENAME
    );

#Chesk existance and define if not exists 
    check_constants($constants);

#load internationalzation
    international_set('tide_news', 'en_US');

#Add admin page navigation 

    function tide_news_nav() {

        echo init_navigation('N', 'tide_news', '<em>N</em>ews');
    }

#Add css files

    function tide_news_css() {

        $css_paths = array(SITE_URL . 'plugins/tide_news/css/tide_news.css');
        echo init_scripts($css_paths, 'css');
    }

#Add javascript files

    function tide_news_js() {

        $js_paths = array(SITE_URL . 'plugins/tide_news/js/tide_news.js');
        echo init_scripts($js_paths, 'js');
    }

#Create all directories we need 

    function tide_news() {

        $storage = get_settings(STORAGE_SETTINGS);

        if (!isset($_POST['storage_type'])) {

            echo load_template(TIDE_NEWS_TEMPLATES . 'install_start.tpl');

            if ($storage['type'] == 'undefined') {
                echo load_template(TIDE_NEWS_TEMPLATES . 'install_form.tpl');
            } else {
                echo '<h2>' . i18n_r('tide_news/PLUGINTITLE') . ':</h2>  
                     <p style="margin:0px 0 5px 0;font-size:12px;color:#999;">' .
                i18n_r('tide_news/PLUGIN_INSTALLED') . '</p><br /><br />';
            }
        } else {

            echo load_template(TIDE_NEWS_TEMPLATES . 'start_after.tpl');

            if ($_POST['storage_type'] == 'mysql') {
                echo '<h2>' . i18n_r('tide_news/PLUGINTITLE') . ':</h2>
                     <p style="margin:0px 0 5px 0;font-size:12px;color:#999;">
                     ' . i18n_r('tide_news/PLUGIN_INSTALL_MSQL') . '</p><br /><br />';
            }

            $news_dir = file_exists(NEWS_DIR);
            $rss_dir = file_exists(NEWS_RSS_DIR);
            $create_news = false;
            $create_rss = false;

            if (!$news_dir) {

                $create_news = create_directory(NEWS_DIR, 'alow');
                echo get_messages($create_news, i18n_r('tide_news/PLUGINCREATE_SUCC'), i18n_r('tide_news/PLUGINCREATE_FAULT'));
            } else {

                echo get_messages(true, i18n_r('tide_news/PLUGINCREATE_EXIST'), '');
            }

            if (!$rss_dir) {
                $create_rss = create_directory(NEWS_RSS_DIR, 'deny');
                echo get_messages($create_rss, i18n_r('tide_news/RSSCREATE_SUCC'), i18n_r('tide_news/RSSCREATE_FAULT'));
            } else {
                echo get_messages(true, i18n_r('tide_news/RSSCREATE_EXIST'), '');
            }

            $file_contents = file_get_contents(GSROOTPATH . '.htaccess');

            $rewrite_add = "#Rule RSS Feed
RewriteRule ^rss-(.*)$ ^index.php?id=rss&page=$1 [L]

#Rule for default navigation older-newer pages
RewriteRule ^(.*)-page-(.*)$ ^index.php?id=$1&show_news&page_number=$2 [L]

#Rewrite for paginate
RewriteRule ^page-(.*)-(.*)-news-(.*)$ ^index.php?id=$1&show_news&page=$2&current_news=$3 [L]

#Rule for pages
RewriteRule ^page-(.*)-news-(.*)$ ^index.php?id=$1&show_news&current_news=$2 [L]

RewriteCond %{REQUEST_FILENAME} !-f";

            $file_contents = str_replace('RewriteCond %{REQUEST_FILENAME} !-f', $rewrite_add, $file_contents);

            $modify_htaccess = file_put_contents(GSROOTPATH . '.htaccess', $file_contents);

            echo get_messages($modify_htaccess, i18n_r('tide_news/HTTACESS_SUCCESS'), i18n_r('tide_news/HTTACESS_FAULT'));

            if ($create_news && $create_rss || ($news_dir && $rss_dir)) {

                $xml_info = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><item></item>');
                $data['type'] = 'xml';
                array_to_xml($data, $xml_info);
                $result = XMLsave($xml_info, STORAGE_SETTINGS);
            } else {

                echo i18n_r('tide_news/CREATE_PROBLEM');
            }

            $source_rss = file_get_contents(PLUGIN_PATH . 'files\rss.xml');
            $create_rss_page = file_put_contents(GSDATAPAGESPATH . 'rss.xml', $source_rss);

            echo get_messages($create_rss_page, i18n_r('tide_news/PAGECREATE_SUCC'), i18n_r('tide_news/PAGECREATE_FAIL'));

            $source_php = file_get_contents(PLUGIN_PATH . 'files\rss.php');
            $themes = find_themes();

            $error = 0;
            foreach ($themes as $key => $value) {
                $create_rss_theme = file_put_contents($value . '/rss.php', $source_php);
                if (!$create_rss_theme) {
                    $error++;
                }
            }
            if ($error > 0) {
                $create_rss_theme = false;
            } else {
                $create_rss_theme = true;
            }

            echo get_messages($create_rss_page, i18n_r('tide_news/PLUGIN_THEME_SUCC'), i18n_r('tide_news/PLUGIN_THEME_FAIL'));
            echo '<div style="text-align: right;"> Proceed to <a href="load.php?id=tide_news&news_settings">Settings</a></div><br /><br />';
        }

        echo load_template(TIDE_NEWS_TEMPLATES . 'install_end.tpl');
    }

#Plugin routing

    function tide_news_router() {

        if (isset($_GET['edit_news'])) {
            edit_news();
        } elseif (isset($_GET['delete_news'])) {
            delete_news();
        } elseif (isset($_GET['create_news'])) {
            create_news();
        } elseif (isset($_GET['news_settings'])) {
            news_settings();
        } elseif (isset($_GET['settings_save'])) {
            settings_save();
        } elseif (isset($_GET['news_overview'])) {
            news_overview();
        } else {
            tide_news();
        }
    }

#Show existing pages andnews 

    function news_overview() {

        if (empty($_GET['news_overview'])) {

            $pages = get_files(GSDATAPAGESPATH, 'xml', true);

            $pages = array_change_values($pages, NEWS_DIR);
            $news = get_files($pages, 'xml', true);

            $text = '<h3>' . i18n_r('tide_news/NEWS_OVERVIEW') . '</h3>';

            foreach ($news as $page => $published) {
                if ($published == 'empty') {
                    $num_of_news = 0;
                    $more = i18n_r('tide_news/NEWS_NO');
                } else {
                    $num_of_news = count($published);
                    $more = '<a href="load.php?id=tide_news&amp;news_overview=' . $page . '">' . i18n_r('tide_news/NEWS_CHECK') . '</a>';
                }

                $text .= '<div class="clear"></div><div class="h5" style="height: 30px">
                <div style="float:left"><b>' . i18n_r('tide_news/NEWS_PAGE') . '<i>' . $page . i18n_r('tide_news/NEWS_P_NEWS') . $num_of_news . '</div>
                <div style="float:right">' . $more . '</div> 
            </div>';
            }
        } else {

            $news = NEWS_DIR . $_GET['news_overview'];
            $news = get_files($news, 'xml');

            $news_number = count($news);
            $page = $_GET['news_overview'];
            $text = '<h3>' . i18n_r('tide_news/NEWS_MANAGEMENT') . ' <u>' . ucfirst($page) . ' ' . i18n_r('tide_news/NEWS_PAGE') . '</u> </h3>
            <form method="post" name="multi_delete"  id="multi_delete" >
                <table class="highlight">
                    <tr>
                        <th>' . i18n_r('tide_news/NEWS_TABLE_TITLE') . '</th>
                        <th style="text-align:right;">' . i18n_r('tide_news/NEWS_TABLE_DATE') . '</th>
                        <th>' . i18n_r('tide_news/NEWS_PREV') . '</th>
                        <th colspan="2">' . i18n_r('tide_news/NEWS_DEL') . '</th>
                    </tr>  <tr>
                        <td colspan="5"></td></tr>';

            if (!empty($news)) {

                $start = 0;
                $times_loop = 20;
                $show_per_page = 20;

                if (!empty($_GET['page_number'])) {

                    $start = $_GET['page_number'] * $show_per_page;
                    $times_loop = $times_loop + $start;

                    if ($times_loop > $news_number) {
                        $times_loop = $news_number;
                    }
                } else {
                    if ($news_number <= $times_loop) {
                        $times_loop = $news_number;
                    }
                }
                for ($i = $start; $i < $times_loop; $i++) {

                    $name = basename($news[$i], ".xml");
                    $data = getXML($news[$i]);
                    $data = html_ent_decode($data);

                    $data['link'] = url_builder($page, $data['slug']);

                    if (strlen($data['title']) > 60) {
                        $data['title'] = substr($data['title'], 0, 60);
                    }

                    $url_name = urlencode($name);
                    $url_news = urlencode($_GET['news_overview']);

                    $text .= '                    
                        <tr>
                        <td class="pagetitle" style="width: 70%">
                            <a href="load.php?id=tide_news&amp;edit_news=' . $url_name . '&amp;page=' . $url_news . '" title="' . i18n_r('tide_news/NEWS_EDIT') . $data['title'] . '">
                                ' . $data['title'] . '
                            </a>
                        </td>
                        <td style="width:80px;text-align:right;">
                            <span>' . $data['date'] . '</span>
                        </td>
                        <td class="secondarylink"><a href="' . SITE_URL . 'index.php?id=' . $url_news . '&amp;show_news&amp;current_news=' . $url_name . '" target="_blank" title="View Page: ' . $_GET['news_overview'] . '">#</a></td> 
                        <td class="delete">
                            <a href="load.php?id=tide_news&amp;delete_news=' . $url_name . '&amp;page=' . $url_news . '" class="tidelete" title="' . i18n_r('tide_news/NEWS_DELETE') . $data['title'] . '?">×</a>
                        </td>
                        <td><input type="checkbox" name="multiple_delete[]" class="delete_checkboxes" value="' . $url_name . '" /></td>
                </tr>';
                }

                $text .= '</table>
                        <input type="hidden" name="page" value="' . $_GET['news_overview'] . '" />
                        <p id="submit_line">
                            <input class="submit tidelete" type="submit" value="' . i18n_r('tide_news/NEWS_DEL_MULT') . '" name="delete_news"    title="Do you want to delete multiple news?">&nbsp;&nbsp;or&nbsp;&nbsp;
                            <a class="cancel" title="Cancel" href="load.php?id=tide_news&amp;news_overview=' . $_GET['news_overview'] . '">Cancel</a>
                        </p>          
            </form>';
            }
            $last = round($news_number / $show_per_page);

            if (empty($_GET['page_number'])) {
                $current_page = 0;
            } else {
                $current_page = $_GET['page_number'];
            }
            if ($show_per_page < $news_number) {
                $pages_array = nav_drop_down($page, range(0, $last));
                $data = nav_old_new($last, $current_page, $page, 'nav_news_admin');

                $text .= load_template(TIDE_NEWS_TEMPLATES . 'nav_default.tpl', $data);
                $text .= '<br /><br />';
            }
        }

        echo $text;
    }

#News delete

    function delete_news() {

        if (isset($_POST['delete_news'])) {
            $delete_items = $_POST['multiple_delete'];
            $page = $_POST['page'];
        } else {
            $delete_items[0] = $_GET['delete_news'];
            $page = $_GET['page'];
        }

        foreach ($delete_items as $key => $value) {

            $file = NEWS_DIR . $page . '/' . $value . '.xml';

            if (file_exists($file)) {

                $result = unlink($file);
                echo get_messages($result, i18n_r('tide_news/NEWS_DELETE_SUCC'), i18n_r('tide_news/NEWS_DELETE_ERROR'), $value);
            } else {
                echo get_messages(false, '', i18n_r('tide_news/NEWS_DELETE_NOFILE'), $value);
            }
        }
    }

#Create news

    function create_news() {

        $data['pages'] = false;
        $data['title'] = 'PAGE TITLE';
        $data['summary'] = '';
        $data['content'] = '';
        $data['slug'] = '';
        $data['keywords'] = '';
        $data['metad'] = '';
        $data['action'] = 'create_news';
        $data['heading'] = 'NEWS_CREATE';
        $data['button_title'] = 'NEWS_SAVE';
        $data['button_action'] = 'create_news';
        $data['cancel'] = '&amp;news_overview';
        $data['old_file_name'] = '';
        $data['date'] = date('j M Y');


        if (isset($_POST['create_news'])) {

            $test = save_news('create');
            if ($test) {
                $data = $test;
            }
            $data['action'] = 'create_news';
            $data['heading'] = 'NEWS_CREATE';
            $data['button_action'] = 'create_news';
            $data['button_title'] = 'NEWS_SAVE';
            $data['cancel'] = '&amp;news_overview';
            $data['old_file_name'] = $data['slug'];
        }

        $data['rich_editor'] = init_editor(array("post-content", "post-summary"), "tide_news");

        $pages = get_files(GSDATAPAGESPATH, 'xml', true);

        $key = array_search('rss', $pages);
        if ($key !== false) {
            unset($pages[$key]);
        }

        $data['page'] = construct_dropdown('post-pages', 'text autowidth', $pages, $data);

        echo load_template(TIDE_NEWS_TEMPLATES . 'create_news.tpl', $data);
    }

#Edit news

    function edit_news() {

        if (empty($_GET['edit_news']) && !isset($_POST['update_news'])) {

            header("Location:load.php?id=tide_news&news_overview");
        } else {

            if (!isset($_POST['update_news'])) {

                $file = NEWS_DIR . $_GET['page'] . '/' . $_GET['edit_news'] . '.xml';
                $name = $_GET['edit_news'];
                $data = @getXML($file);

                $data = html_ent_decode($data);
                $data['action'] = 'edit_news';
                $data['heading'] = 'NEWS_EDIT';
                $data['button_title'] = 'NEWS_UPDATE';
                $data['button_action'] = 'update_news';
                $data['cancel'] = '&amp;news_overview=' . $_GET['page'];
                $data['old_file_name'] = $data['slug'];
            }

            if (isset($_POST['update_news'])) {

                $data = save_news('update');

                $data['action'] = 'edit_news';
                $data['heading'] = 'NEWS_EDIT';
                $data['button_title'] = 'NEWS_UPDATE';
                $data['button_action'] = 'update_news';
                $data['cancel'] = '&amp;news_overview=' . $data['pages'];
                $data['old_file_name'] = $_POST['post-slug'];
            }

            $data['rich_editor'] = init_editor(array("post-content", "post-summary"), "tide_news");

            $pages = get_files(GSDATAPAGESPATH, 'xml', true);

            $data['page'] = construct_dropdown('post-pages', 'text autowidth', $pages, $data['pages']);

            echo load_template(TIDE_NEWS_TEMPLATES . 'create_news.tpl', $data);
        }
    }

#News save

    function save_news($action) {

        $data = array_map('trim', $_POST);
        $data = html_ent($data);
        $settings = get_settings();
        if ($action == 'create') {

            unset($data['create_news']);
            $data['date'] = date('j M Y');
            $data = array_keys_rename($data, 'post-', '');

            if (empty($data['slug'])) {

                $data['slug'] = str_replace(' ', '_', $data['title']);
            } else {

                $data['slug'] = str_replace(' ', '_', $data['slug']);
            }
            unset($data['oldtitle']);
            if (strtolower($data['title']) == 'page title') {
                echo get_messages(false, '', i18n_r('tide_news/NEWS_TITLE_ERROR'));

                $result = $data;
            } else {
                $news_dir = NEWS_DIR . $data['pages'];
                $news_file = $news_dir . '/' . $data['slug'] . '.xml';
                if (!file_exists($news_dir)) {
                    create_directory(NEWS_DIR . $data['pages']);
                }

                if (file_exists($news_file)) {
                    echo get_messages(false, '', i18n_r('tide_news/NEWS_SAVE_DUPLICATE'));
                    $data['slug'] = '';
                    $result = $data;
                } else {
                    $xml_info = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><item></item>');
                    array_to_xml($data, $xml_info);
                    $result = XMLsave($xml_info, $news_file);

                    if (!$result) {
                        echo '<div class="error">' . i18n_r('tide_news/NEWS_SAVE_ERROR') . '</div>';
                        $result = $data;
                    } else {
                        echo '<div class="updated">' . i18n_r('tide_news/NEWS_SAVE_SUCC') . '</div>';
                        $result = false;
                    }
                }
            }
        } elseif ($action == 'update') {

            unset($data['update_news']);
            $data['modified'] = date('j M Y');
            if (empty($data['date'])) {
                $data['modified'] = date('j M Y');
            }
            $data = array_keys_rename($data, 'post-', '');

            if (empty($data['slug'])) {
                $data['slug'] = str_replace(' ', '_', $data['title']);
            } else {
                $data['slug'] = str_replace(' ', '_', $data['slug']);
            }

            $news_dir = NEWS_DIR . $data['pages'];
            $news_file = $news_dir . '/' . $data['slug'] . '.xml';

            if ($data['slug'] !== $data['oldtitle']) {

                $renamed = rename($news_dir . '/' . $data['oldtitle'] . '.xml', $news_dir . '/' . $data['slug'] . '.xml');

                echo get_messages($renamed, i18n_r('tide_news/NEWS_RENAME_SUCC'), i18n_r('tide_news/NEWS_RENAME_ERROR'));
            }
            $data['modified'] = i18n_r('tide_news/NEWS_MOD') . ': ' . date('j M Y');
            unset($data['oldtitle']);

            $xml_info = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><item></item>');
            array_to_xml($data, $xml_info);
            $saved = XMLsave($xml_info, $news_file);

            echo get_messages($saved, i18n_r('tide_news/NEWS_UPDATE_SUCC'), i18n_r('tide_news/NEWS_UPDATE_ERROR'));
            $result = $data;
        }
        if ($settings['feed_auto'] == 'checked') {
            rss_generate($action);
        }
        return $result;
    }

#Plugin settings

    function news_settings() {

        if (isset($_POST['settings_save'])) {
            settings_save();
        }

        $settings = getXML(NEWS_SETTINGS);
        $data = html_ent_decode($settings);

        $pages_num = range(1, 10);
        $menu_man = array(i18n_r('tide_news/S_MENU_WARP'), i18n_r('tide_news/S_MENU_CUT'));
        $news_number = array('5', '6', '7', '8', '9', '10', '15', '20', '30');
        $navigation_type = array(i18n_r('tide_news/S_NEWS_PAG_DEF'), i18n_r('tide_news/S_NEWS_PAG_PAG'), i18n_r('tide_news/S_NEWS_PAG_DROP'));
        $images_list = get_files(GSDATAPATH . '/uploads', '', true);
        $feed = array('1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '15', '20', '30', '40');
        $feed_generate = array('pages' => 'pages feeds', 'single' => 'general feed', 'mixed' => 'pages&amp;general feed');
        $icons = get_files(PLUGIN_PATH . '/icons', '.png', true);
        $lang_array = installed_languages();

        if (!$images_list) {

            $data['feed_images'] = '<a href="' . SITE_URL . 'admin/upload.php" >' . i18n_r('tide_news/S_RSS_IMG_UP') . '</a>';
            $data['image'] = '#';
        } else {
            $data['feed_images'] = construct_dropdown('feed_image', 'text', $images_list);
            $data['feed_images'] = construct_dropdown('feed_image', 'text', $images_list, basename($data['feed_image']));
            $data['image'] = SITE_URL . 'data/thumbs/thumbsm.' . $data['feed_image'];
        }
        $data['external_exist'] = '';
        if (!function_exists('get_external_comments')) {
            $data['external_exist'] = '<p>' . i18n_r('tide_news/S_EXTERNAL') . '
                <a href="http://get-simple.info/extend/plugin/external-commenting/73/">
                 ' . i18n_r('tide_news/S_NEWS_COMM_INT') . '
                </a>
            </p>';
        }

        $data['menu_news_number'] = construct_dropdown('menu_news_number', 'text', $pages_num, $data['menu_news_number']);
        $data['menu_man'] = construct_dropdown('menu_man', 'text', $menu_man, $data['menu_man']);
        $data['news_page_number'] = construct_dropdown('news_page_number', 'text', $news_number, $data['news_page_number']);
        $data['navigation_type'] = construct_dropdown('navigation_type', 'text', $navigation_type, $data['navigation_type']);
        $data['feed_lang'] = construct_dropdown('feed_lang', 'text', $lang_array, $data['feed_lang']);
        $data['feed_num'] = construct_dropdown('feed_num', 'text', $feed, $data['feed_num']);

        $data['icon'] = SITE_URL . 'plugins/tide_news/icons/' . $data['feed_icon'];
        $data['feed_icon'] = construct_dropdown('feed_icon', 'text', $icons, $data['feed_icon']);
        $data['feed_generate'] = construct_dropdown('feed_generate', 'text', $feed_generate, $data['feed_generate'], '', true);

        echo load_template(TIDE_NEWS_TEMPLATES . 'settings.tpl', $data);
    }

#Save plugin settings

    function settings_save() {

        $_POST['feed_enable'] = (isset($_POST['feed_enable']) ? 'checked' : '');
        $_POST['menu_enable'] = (isset($_POST['menu_enable']) ? 'checked' : '');
        $_POST['external_comments'] = (isset($_POST['external_comments']) ? 'checked' : '');
        $_POST['feed_auto'] = (isset($_POST['feed_auto']) ? 'checked' : '');
        unset($_POST['settings_save']);
        if ($_POST['external_comments'] == 'checked' && !file_exists(GSPLUGINPATH . 'external_comments.php')) {

            echo get_messages(false, '', i18n_r('tide_news/S_EXTERNAL_ERROR'));
            $_POST['external_comments'] = '';
        }
        $data = html_ent($_POST);
        $xml_info = new SimpleXMLElement('<?xml version="1.0" encoding="UTF-8"?><item></item>');
        array_to_xml($data, $xml_info);
        $result = XMLsave($xml_info, NEWS_SETTINGS);

        echo get_messages($result, i18n_r('tide_news/S_SAVE_SUCC'), i18n_r('tide_news/S_SAVE_ERROR'));
    }

    #Show pages list with number of news and show news list by pahe

    function show_news($page) {

        if (!isset($_GET['current_news'])) {
            global $news;
            global $news_number;
            global $settings;

            if (!isset($news)) {
                $news = get_page_news($page);
            }
            if (!isset($news_number)) {
                $news_number = count($news);
            }
            if (!isset($settings)) {
                $settings = get_settings();
            }

            $start = 1;
            $times_loop = $settings['news_page_number'] + 1;

            if (!empty($_GET['page_number'])) {
                if ($_GET['page_number'] > 1) {
                    $start = (($_GET['page_number'] - 1) * $settings['news_page_number']) + 1;
                    $times_loop = $times_loop + $start - 1;
                }
            }
            if ($times_loop >= $news_number + 1) {
                $times_loop = $news_number + 1;
            }


            $combine = '<h1 id="tide_news_page">' . ucwords($page) . '  ' . i18n_r('tide_news/NEWS_PAGE_TITLE') . '</h1>';
            if (empty($_GET['page_number'])) {
                $current_page = 1;
            } else {
                $current_page = $_GET['page_number'];
            }

            for ($i = $start; $i < $times_loop; $i++) {

                $data = getXML($news[$i - 1]);
                $data = html_ent_decode($data);

                if ($news_number > $settings['news_page_number']) {
                    $data['link'] = url_builder_pages($page, $data['slug'], $current_page);
                } else {
                    $data['link'] = url_builder($page, $data['slug']);
                }

                if (!empty($data['summary'])) {
                    $data['content'] = $data['summary'] . '<div class="tide_news_read_more"><a href="' . $data['link'] . '">' . i18n_r('tide_news/NEWS_READ_MORE') . ' . . .</a></div>';
                }
                $data['page_title'] = i18n_r('tide_news/NEWS_IN') . get_page_clean_title(false);

                $combine .= load_template(TIDE_NEWS_TEMPLATES . 'news.tpl', $data);
            }

            if ($times_loop == 1) {
                $combine .= load_template(TIDE_NEWS_TEMPLATES . 'no_news.tpl');
            }
            $last = round(($news_number + 1) / $settings['news_page_number']);

            $modus = $news_number % $settings['news_page_number'];

            if ($modus == 1) {
                $select = $last;
                $last++;
            } elseif ($modus > 1 && $modus < 5 || ($modus == 0)) {
                $select = --$last;
                $last++;
            }
            $pages_array = nav_drop_down($page, range(0, $select), true);

            if ($settings['news_page_number'] < $news_number) {

                switch ($settings['navigation_type']) {
                    case 'paginate':

                        if ($news_number > $settings['news_page_number']) {
                            $data = nav_paginate($last, $current_page, $pages_array, $settings['news_page_number']);
                            $combine .= load_template(TIDE_NEWS_TEMPLATES . 'nav_paginate.tpl', $data);
                        }
                        break;
                    case 'drop down':
                        $g_page = nav_drop_down($page, array($current_page));
                        $pages_array = array_flip($pages_array);
                        $data['drop_down'] = construct_dropdown('tide_drop_down', 'text', $pages_array, $g_page[0], 'onchange="window.open(this.options[this.selectedIndex].value,\'_top\')"', true);
                        $combine .= load_template(TIDE_NEWS_TEMPLATES . 'nav_drop_down.tpl', $data);

                        break;
                    default:
                        $data = nav_old_new($last, $current_page, $page, 'nav_default');
                        $combine .= load_template(TIDE_NEWS_TEMPLATES . 'nav_default.tpl', $data);
                }
            }

            echo $combine;
        } else {

            $data = getXML(NEWS_DIR . $_GET['id'] . '/' . $_GET['current_news'] . '.xml');

            $data = html_ent_decode($data);
            $data['link'] = url_builder($page, $data['slug']);
            if (empty($data['summary'])) {
                $data['summary'] = $data['content'];
            }
            if (isset($data['modified'])) {
                $data['content'] .= '<div class="tide_news_date">' . $data['modified'] . '</div>';
            }
            $data['page_title'] = '';
            set_headers($data);
            echo load_template(TIDE_NEWS_TEMPLATES . 'news.tpl', $data);

            if ($settings['external_comments'] = "checked" && function_exists('get_external_comments')) {
                $data['icon'] = SITE_URL . 'plugins/tide_news/icons/';
                echo load_template(TIDE_NEWS_TEMPLATES . 'comments.tpl', $data);
            }
        }
    }

#In calse that eval_php_in_content plugin is not installed

    function evaluate_php_code($c) {

        $c = eval("?>" . stripslashes(htmlspecialchars_decode($c, ENT_QUOTES)) . "<?php ");
        return $c;
    }

#Generate RSS feed - direct access and generation every time you create or edir some news

    function rss_generate($action = 'create') {

        $news = get_news();
        $settings = get_settings();
        unset($news['rss']);

        switch ($settings['feed_generate']) {
            case 'pages':
                $result = create_rss($news, $settings);
                break;
            case 'single':
                $result = create_rss($news, $settings, 'aggregate');
                break;
            case 'mixed':
                $result[] = create_rss($news, $settings, 'aggregate');
                $result[] = create_rss($news, $settings);
                $result = call_user_func_array('array_merge', $result);
                break;
        }
        if ($action == 'create') {
            $fault = i18n_r('tide_news/S_RSS_CREATE_ERROR');
            $success = i18n_r('tide_news/S_RSS_CREATE_SUCC');
        } else {
            $fault = i18n_r('tide_news/S_RSS_UPDATE_ERROR');
            $success = i18n_r('tide_news/S_RSS_UPDATE_SUCC');
        }

        foreach ($result as $key => $value) {
            echo get_messages($value, $success, $fault, $key);
        }
    }

#Show RSS Feed you must have page named RSS and use rss.php as template

    function rss_feed($page) {

        $rss = file_get_contents(NEWS_RSS_DIR . $page . '.xml');

        echo $rss;
    }

#Add RSS Feed menu add code <?php rss_feed_menu(return_page_slug()); ?/>

    function rss_feed_menu($page) {

        $settings = get_settings();

        $settings['feed_icon'] = SITE_URL . 'plugins/tide_news/icons/' . $settings['feed_icon'];

        if ($settings['feed_enable'] == 'checked') {
            if ($settings['feed_generate'] == 'single' || ($page == 'index' && $settings['feed_generate'] == 'mixed')) {
                $page = 'aggregate';
            }

            $settings['link'] = rss_buider($page);
        } else {

            $settings['link'] = '#';
            $settings['feed_description'] = i18n_r('tide_news/S_RSS_DISABLED');
        }

        echo load_template(TIDE_NEWS_TEMPLATES . 'rss_menu.tpl', $settings);
    }

#latest news menu for pages add code <?php news_menu(return_page_slug()); ?/>

    function news_menu($page) {
        $settings = get_settings();
        $news = get_page_news($page);
        if ($settings['menu_enable'] == 'checked') {
            if ($news !== 'empty') {

                if (count($news) > $settings['menu_news_number']) {
                    $news = array_slice($news, 0, $settings['menu_news_number']);
                }
            }
            $text = '<div class="tide_news_menu">
            <div class="tide_news_menu_title">' . ucwords($settings['menu_title']) . '</div>
                <div class="tide_news_menu_latest">
                    <div class="tide_news_menu_list">';

            for ($i = 0; $i < count($news); $i++) {

                $data = getXML($news[$i]);
                $data = html_ent_decode($data);

                if (strlen($data['title']) > $settings['menu_title_lenght']) {

                    if ($settings['menu_man'] == 'warp') {
                        $data['title'] = wordwrap($data['title'], $settings['menu_title_lenght'], true);
                    } else {
                        $data['title'] = substr($data['title'], 0, $settings['menu_title_lenght']) . ' ...';
                    }
                }

                $data['link'] = url_builder($page, $data['slug']);

                if (!empty($data['summary'])) {
                    $data['summary'] = $data['content'];
                }

                $data['summary'] = strip_tags($data['summary']);

                if (strlen($data['summary']) > $settings['menu_title_lenght']) {

                    if ($settings['menu_man'] == 'warp') {
                        $data['summary'] = wordwrap($data['summary'], $settings['menu_content_lenght'], true);
                    } else {
                        $data['summary'] = substr($data['summary'], 0, $settings['menu_content_lenght']) . ' ...';
                    }
                }

                $text .= '<div class="tide_news_menu_item">-<a href="' . $data['link'] . '">' . $data['title'] . '</a></div>';
                $text .= '<div class="tide_news_menu_content">' . $data['summary'] . '</div>';
            }
            $text .= '</div></div></div>';

            if (empty($text)) {
                $text .= 'No news in this moment';
            }
            echo $text;
        }
    }

# Set News Headers

    function set_headers() {
        global $metad;
        global $metak;
        global $title;

        if (isset($_GET['current_news'])) {
            $data = getXML(NEWS_DIR . $_GET['id'] . '/' . $_GET['current_news'] . '.xml');
            $data = html_ent_decode($data);

            if (empty($data['metad']) || empty($data['keywords'])) {
                $page = getXML(GSDATAPAGESPATH . $_GET['id'] . '.xml');
                $data = html_ent_decode($data);
                if (empty($data['keywords'])) {
                    $data['keywords'] = $page->metak;
                }
                if (empty($data['metad'])) {
                    $data['metad'] = $page->metad;
                }
                $data['metak'] = $page->metak;
            }



            $metad = preg_replace('/[\s]+/', ' ', $data['metad']);
            $metak = $data['keywords'];
            $title = $data['title'];
        } else {

            if (strlen(trim($metad)) == 0) {

                $metad = return_page_title();
            }
        }
    }

# Pages/ News Breadcrumbs

    function news_breadcrumbs() {

        $start_page = '<div class="parallelogram" ><a href="' . SITE_URL . '">Home</a></div>';

        if (isset($_GET['id']) && $_GET['id'] !== 'index') {

            $page_data = get_settings(GSDATAPAGESPATH . $_GET['id'] . '.xml');

            if ($page_data['parent']) {
                $page_data_parent = get_settings(GSDATAPAGESPATH . $page_data['parent'] . '.xml');

                if ($page_data_parent['parent']) {
                    $page_data_parent_1 = get_settings(GSDATAPAGESPATH . $page_data_parent['parent'] . '.xml');

                    if ($page_data_parent_1['parent']) {
                        $page_data_parent_2 = get_settings(GSDATAPAGESPATH . $page_data_parent['parent'] . '.xml');
                        if ($page_data_parent_2['parent'] !== 'index') {
                            $start_page .= ' &nbsp;&nbsp;&#149;&nbsp;&nbsp; <a href="' . find_url($page_data_parent_2['url'], '') . '">' . $page_data_parent_2['title'] . '</a></div>';
                        }
                    }
                    if ($page_data_parent_1['parent'] !== 'index') {
                        $start_page .= '<div class="parallelogram" ><a href="' . find_url($page_data_parent_1['url'], '') . '">' . $page_data_parent_1['title'] . '</a></div>';
                    }
                }
                if ($page_data['parent'] !== 'index') {
                    $start_page .= '<div class="parallelogram" ><a href="' . find_url($page_data_parent['url'], '') . '">' . $page_data_parent['title'] . '</a></div>';
                }
            }

            $start_page .= '<div class="parallelogram" ><a href="' . find_url($_GET['id'], '') . '">' . $page_data['title'] . '</a></div>';
        }

        if (!isset($_GET['id'])) {
            $_GET['id'] = 'index';
        }
        if (isset($_GET['page_number']) || isset($_GET['page'])) {

            if (isset($_GET['page'])) {
                $num = $_GET['page'];
            } else {
                $num = $_GET['page_number'];
            }
            $url = nav_drop_down($_GET['id'], array($num));

            $start_page .= '<div class="parallelogram" ><a href="' . $url[0] . '">Page ' . $num . '</a></div>';
        } else {
            global $news;
            global $news_number;
            global $settings;
            $news = get_page_news($_GET['id']);
            $news_number = count($news);
            $settings = get_settings();
            $news_page_num = round($news_number / $settings['news_page_number']);

            if ($news_page_num > 0) {
                $url = nav_drop_down($_GET['id'], array(0));

                $start_page .= '<div class="parallelogram" ><a href="' . $url[0] . '">Page 1</a></div>';
            }
        }

        if (isset($_GET['current_news'])) {
            global $title;
            $start_page .= '<div class="parallelogram" >' . $title . '</div>';
        }


        echo $start_page;
    }

    